/* File: vldtn.h */                  

/*-----------------------------------------------------------------**
** Copyright (C) The Higher Education Statistics Agency 1994,1995  **
** Authors:                                                        **
** 	Duncan Charlton: DuncanC@hesa.ac.uk                            **
** 	Adrian Crossley: AdrianC@hesa.ac.uk                            **
**-----------------------------------------------------------------*/


/*--------------------------------------**
** #define ANSI here for ANSI compilers **
** DO NOT #define it for K&R compilers  **
**--------------------------------------*/

/* 2005-05-05 MDE added declaration of INSTCAMPS  */

#if __STDC__ == 1		/* IF STDC Use ANSI */
#define ANSI
#endif

#ifdef _MSC_VER			/* This is an internal build so use ANSI */
#define ANSI
#endif


#if HESABUILD  == 1		/* Check gcc with ansi */
#define ANSI
#endif

#if HESABUILD  == 2		/* Check gcc  without ansi*/
#undef ANSI
#endif



#include <stdio.h>

/*
 * Version Info
 */

#define VERMAJ "2"
#define VERMIN "27"
/*06/08/97 Added If festumk = 3 in rule 2147*/ 
/*05/08/97 StripChar Function added to helper.c to correct GetSub() and GetSub13() problem*/ 
/*04/08/97  2.25  Warning 2127 Field 30  for 96011 and  2251 for 96012 amended */ 
/*04/08/97  2/24   functions GetSub() and GetSub13() altered to use ints as internal problem with floats */
/*21/06/96  2.23   function BOOL IsValidUnPaddedInteger(UINT,ULONG,ULONG) added */
/*03/06/96  2.22   function double GetFieldNoDouble(UINT) added */
/*16/01/96  2.21a  _IsValidCode Changed for strncmp(psz,psz,MAX)*/
              
/* ===================================================================*/              
              
/*
 * Local information
 */

/* The maximum length of a pathname */
#define FPSIZE 255               
/* The size of the input buffer */
#define LBSIZE 4096
/* The maximum number of rules we can ignore */
#define IRCOUNT 64


/* ===================================================================*/              


/*
 * Fatal Errors
 */

#define IERR_USAGE 0x01
#define IERR_MINPUT 0x02
#define IERR_SWITCH 0x03
#define IERR_FINPUT 0x04
#define IERR_FOUTPUT 0x05
#define IERR_MEMORY 0x06

/*
 * Supported File types
 */

#define TY_CSV 0x01 /* Type is Comma Separated Value */
#define TY_TSV 0x02 /* Type is Tab Separated Value */
#define TY_FIX 0x03 /* Type is Fixed Length */
#define MAX_GS 10	  /* Max number of global switches */


#define WARNINGLEVEL 10



/*
 * Define some common types
 */
extern unsigned int uinFields;
extern unsigned int uiKeyField;
extern int iCentYear;
extern int iCurrentYear;
#define BOOL unsigned int
#define UINT unsigned int
#define ULONG unsigned long
#define SLONG signed long
#define PSZ char *
#define SZ char

#define YEAR 	0x01
#define MONTH 0x02
#define DAY 	0x03
#define ERRDATE 0x0FFFFFFF
#define LEFT    0x04
#define RIGHT   0x05 
/* ~ #define MAX_ERRORS_PER_FIELD 5  */
#ifdef ANSI

/* ~             
struct ERROR_INFO{
	UINT FieldNo;
	char * Abbrev;
struct Errors *pstErrors; 	
}Error_Object[147];
*/

struct ERROR{  
		UINT uiFieldNo;
	  	UINT uiErrorNumber;   
	  	UINT uiSeverity;
 		UINT uiErrorTotal;  
    	};

 
struct FLD {
	UINT uiNo;
	SZ   szAbbrev[16];
	UINT uiType;                            	
	UINT uiLength;
	UINT uiOffset;
	UINT uiDecember;
	UINT (*pfVld)(void);
	UINT (*pfRqd)(int bMacro);
	UINT uinValid;
	UINT uinAlloc;
	PSZ	 *ppszValids;
	BOOL bIgnore;
	}; 

#else

struct FLD {
	UINT uiNo;
	SZ   szAbbrev[16];
	UINT uiType;                            	
	UINT uiLength;
	UINT uiOffset;
	UINT (*pfVld)();
	UINT (*pfRqd)();
	UINT uinValid;
	UINT uinAlloc;
	PSZ	 *ppszValids;
	BOOL bIgnore;
	}; 


#endif
 
/* added ouType MDE 2006-02-21 */
 
struct tagOptions {
	UINT uiType;
	BOOL bRawOutput;
	BOOL bDBOutput;
	BOOL bVerbose;
	BOOL bExplain;
	BOOL bControl;
	BOOL bGlobal[MAX_GS];
	BOOL bBreak;
	BOOL bNoValid;
	UINT uiDiag;
	UINT uiReduced;
	BOOL bNegate;
	BOOL bQuiet;
	BOOL bPipe;
	BOOL bIgnoreFatal;
	UINT uoType;
	}; 


struct RULE {
	ULONG ulRule;
	ULONG ulOffset;
	};     
struct DFQ {
	int iFieldNo;
	char ValidItem[32];
	};	
	

/* From vmain.c */

#ifdef ANSI
void ErrExit(UINT uiError);
#else
void ErrExit();
#endif

extern SZ szMsgBuffer[];
extern FILE *pfError;
extern FILE *pfError1;
extern FILE *pfError2;
extern FILE *pfError3;
extern FILE *pfError4;
extern FILE *pfExplanErr;
extern UINT uiCurFieldNo;
extern ULONG ulCurRecordNo;	
extern UINT	uiWarning;
extern ULONG uinError; 
extern UINT uinRules;
extern ULONG ulMaxWarnings;
extern ULONG uinWarning;
extern UINT uicIgnoreRules;
extern ULONG ulIgnoreRules[];
extern SZ szAuxPath[];
extern BOOL gbLateResultReturn;
SZ szInstFromFileName[16];
extern long ulConnection;

#define PIPING (Options.bPipe)


/* From yynnn.c */
/* 2006-02-21 MDE added RuleText[]  */

extern UINT uiRNo;
extern SZ szLRNo[];
extern UINT uiRLength;
extern UINT uinFields;
extern UINT uiSeverity;
extern char RuleText[];
extern SZ szValidFile[];
extern SZ szErrorFile[];
extern SZ szError1File[];
extern SZ szWarningFile[];
extern SZ szTotalsFile[];
extern SZ szLongDescFile[];
extern SZ szInfoFile[];
extern SZ szBinFile[];    
extern SZ szExplanErrFile[];
extern int uiNeedsPostcode;
extern int uiNeedsJACScode;
extern SZ szVRVer[];
extern SZ szDateWritten[];
extern struct FLD stFields[]; 
/* ~ extern struct DFQ DeFunctStudentCodes[]; */
extern char DeFunctStudentCodes12[][6];
extern char DeFunctStudentCodes13[][6];
extern char DeFunctStudentCodes14[][6];
extern char DeFunctStudentCodes21[][6];
extern char DeFunctStudentCodes70[][6];
extern char JACSCODENORMAL[][6];
extern char OLDINSTLIST[][6];     
extern char TTAFUNDED[][6];
extern char SBJ2002[][6];
extern char SBJ2004A[][6];
extern char SBJ2004B[][6];
extern char CAMPLIST_STUDENT[][6];
extern char CAMPLIST_STAFF[][6];
extern char SBJQAWTT2426[][6];
extern char SBJQAETT2426[][6] ;
extern char SBJQAEW1519[][6] ;
extern char SBJQAW1519[][6] ;
extern char VETSCHOOL[][6];
extern char MEDSCHOOL[][6];
extern char FTEMETHOD1[][6];
extern char FTEMETHOD2[][6];
extern char FTEMETHOD3[][6];
extern char FTEMETHOD4[][6];
extern char HISTORICSTAFFINST[][6];

extern struct ERROR stErrors[]; 
/* ~  extern struct ERROR_INFO stError_Info[]; */
extern struct Errors;
/* From filehelp.c */

#ifdef ANSI
	int GetLineOffsetsCSV (struct FLD *pfld,PSZ pszLine);
	int GetLineOffsetsFIX(PSZ pszLine);
	unsigned int GetLineOffsetsTSV (PSZ pszLine);
	BOOL ReadValidEntries(void);
	BOOL ReadJACSCODE(void);
	BOOL ReadPostCODE(void);
	BOOL ReadErrorTable(void);
	PSZ GetErrorString(ULONG ulRule);
	BOOL IsValidJacsCode(const PSZ lps);
	BOOL IsValidJacsCode6(UINT uiFieldNo);
	BOOL IsValidJacsCode6_AnyJust(UINT uiFieldNo);
	BOOL IsValidMultiJacs(UINT uiFieldNo);
	BOOL IsValidPostCode(const PSZ lps);
	char *stralloc(const char *ps);
	BOOL OutputCleanField(UINT uiValResult,UINT uiFieldNo,FILE * pf);
#else
	int GetLineOffsetsCSV ();
	int GetLineOffsetsFIX();
	unsigned int GetLineOffsetsTSV();
	BOOL ReadValidEntries();
	BOOL ReadJACSCODE();
	BOOL ReadPostCODE();
	BOOL ReadErrorTable();
	PSZ GetErrorString();
	BOOL IsValidJacsCode();
	BOOL IsValidJacsCode6();
	BOOL IsValidJacsCode6_AnyJust();
	BOOL IsValidMultiJacs();
	BOOL IsValidPostCode();  
	char *stralloc();
	BOOL OutputCleanField();
#endif
/* from helper.c*/ 
                 
/* ~ extern int Error_Count; */
extern unsigned int REALLOCUNIT;
/* ~ static int Error_Totals[147];  */
/* From nprofile.c */
#ifdef ANSI
int FileGetPrivateProfileString(const char *psSection,const char *psEntry,const char *psDefault,char *psReturnBuffer,int cbReturnBuffer,const char * psFilename);
int FileWritePrivateProfileString(const char *psSection,const char *psEntry,const char *psValue,const char *psFilename);
#else
int FileGetPrivateProfileString();
int FileWritePrivateProfileString();
#endif


struct RULE *prlRules;
extern FILE *pfErrors;

extern SZ szLineBuffer[];

extern struct tagOptions Options;

#ifndef ANSI
#define SEEK_SET 0
#endif

